using FishFactoryContracts.BindingModels;
using FishFactoryContracts.SearchModels;
using FishFactoryContracts.StoragesContracts;
using FishFactoryContracts.ViewModels;
using FishFactoryFileImplement.Models;

namespace FishFactoryFileImplement.Implements
{
    public class OrderStorage :IOrderStorage
    {
        private readonly DataFileSingleton source;
        public OrderStorage()
        {
            source = DataFileSingleton.GetInstance();
        }

        public List<OrderViewModel> GetFullList()
        {
            return source.Orders.Select(x => GetViewModel(x)).ToList();
        }

        public List<OrderViewModel> GetFilteredList(OrderSearchModel model)
        {
            if (model.DateFrom.HasValue && model.DateTo.HasValue)
                return source.Orders
                    .Where(x => x.DateCreate >= model.DateFrom && x.DateCreate <= model.DateTo)
                    .Select(x => GetViewModel(x))
                    .ToList();
            else if (model.ClientId.HasValue && !model.Id.HasValue)
                return source.Orders
                    .Where(x => x.ClientId == model.ClientId)
                    .Select(x => x.GetViewModel)
                    .ToList();
            else if (model.OrderStatus.HasValue)
                return source.Orders
                    .Where(x => x.Status == model.OrderStatus)
                    .Select(x => x.GetViewModel)
                    .ToList();
            else if (model.Id.HasValue)
                return source.Orders
                    .Where(x => x.Id.Equals(model.Id))
                    .Select(x => GetViewModel(x))
                    .ToList();
            return new();
        }

        public OrderViewModel? GetElement(OrderSearchModel model)
        {
            if (model.Id.HasValue)
            {
                return source.Orders.FirstOrDefault(x => x.Id == model.Id)?.GetViewModel;
            }
            else if (model.ImplementerId.HasValue && model.OrderStatus.HasValue)
            {
                return source.Orders
                    .FirstOrDefault(x => x.ImplementerId == model.ImplementerId && x.Status == model.OrderStatus)
                    ?.GetViewModel;
            }
            else if (model.ImplementerId.HasValue)
            {
                return source.Orders
                    .FirstOrDefault(x => x.ImplementerId == model.ImplementerId)
                    ?.GetViewModel;
            }
            return null;
        }
        private OrderViewModel GetViewModel(Order order)
        {
            var viewModel = order.GetViewModel;

            var canned = source
                .ListCanned.FirstOrDefault(x => x.Id == order.CannedId);
            var client = source
                .Clients.FirstOrDefault(x => x.Id == order.ClientId);
			var implementer = source
                .Implementers.FirstOrDefault(x => x.Id == order.ImplementerId);

            if (canned != null)
                viewModel.CannedName = canned.CannedName;
            if (client != null)
                viewModel.ClientFIO = client.ClientFIO;
			if (implementer != null)
                viewModel.ImplementerFIO = implementer.ImplementerFIO;
            return viewModel;
        }
        public OrderViewModel? Insert(OrderBindingModel model)
        {
            model.Id = source.Orders.Count > 0 ? source.Orders.Max(x => x.Id) + 1 : 1;
            var newOrder = Order.Create(model);
            if (newOrder == null)
            {
                return null;
            }
            source.Orders.Add(newOrder);
            source.SaveOrders();
            return GetViewModel(newOrder);
        }

        public OrderViewModel? Update(OrderBindingModel model)
        {
            var order = source.Orders.FirstOrDefault(x => x.Id == model.Id);
            if (order == null)
            {
                return null;
            }
            order.Update(model);
            source.SaveOrders();
            return GetViewModel(order);
        }

        public OrderViewModel? Delete(OrderBindingModel model)
        {
            var element = source.Orders.FirstOrDefault(x => x.Id == model.Id);
            if (element != null)
            {
                source.Orders.Remove(element);
                source.SaveOrders();
                return GetViewModel(element);
            }
            return null;
        }
    }
}
